// Copyright (c) 2022 Conviva All rights reserved.
//
// This program is licensed to you under the Apache License Version 2.0,
// and you may not use this file except in compliance with the Apache License Version 2.0.
// You may obtain a copy of the Apache License Version 2.0 at http://www.apache.org/licenses/LICENSE-2.0.
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the Apache License Version 2.0 is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the Apache License Version 2.0 for the specific language governing permissions and limitations there under.

package com.conviva.flutter.apptracker.readers.events

import com.conviva.apptracker.event.SelfDescribing
import com.conviva.apptracker.payload.SelfDescribingJson

class SelfDescribingJsonReader(val values: Map<String, Any>) {
    val schema: String by values
    val data: Map<String, Any> by values

    fun toSelfDescribingJson(): SelfDescribingJson {
        return SelfDescribingJson(schema, data)
    }

    fun toSelfDescribing(): SelfDescribing {
        return SelfDescribing(toSelfDescribingJson())
    }
}
