// Copyright (c) 2022 Conviva All rights reserved.
//
// This program is licensed to you under the Apache License Version 2.0,
// and you may not use this file except in compliance with the Apache License Version 2.0.
// You may obtain a copy of the Apache License Version 2.0 at http://www.apache.org/licenses/LICENSE-2.0.
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the Apache License Version 2.0 is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the Apache License Version 2.0 for the specific language governing permissions and limitations there under.

package com.conviva.flutter.apptracker.readers.events

import com.conviva.apptracker.event.Timing

class TimingReader(val values: Map<String, Any>) {
    private val valuesDefault = values.withDefault { null }

    val category: String by values
    val variable: String by values
    val timing: Int by values
    val label: String? by valuesDefault

    fun toTiming(): Timing {
        val timing = Timing(category, variable, timing)
        label?.let { timing.label(it) }
        return timing
    }
}
