// Copyright (c) 2022 Conviva All rights reserved.
//
// This program is licensed to you under the Apache License Version 2.0,
// and you may not use this file except in compliance with the Apache License Version 2.0.
// You may obtain a copy of the Apache License Version 2.0 at http://www.apache.org/licenses/LICENSE-2.0.
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the Apache License Version 2.0 is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the Apache License Version 2.0 for the specific language governing permissions and limitations there under.

import Foundation
import ConvivaAppAnalytics

struct PageViewReader: Decodable {
    let pageUrl: String?
    let pageTitle: String?
    let referrer: String?
}

extension PageViewReader {
    func toPageView() -> CATPageView {
        let event = CATPageView(pageUrl: pageUrl ?? "unknown")
        if let pageTitle = self.pageTitle {event.pageTitle(pageTitle)}
        if let referrer = self.referrer {event.pageTitle(referrer)}
        return event
    }
}
